<?php

class InfoController extends CController
{
	/**
	 * @var string specifies the default action to be 'list'.
	 */
	public $defaultAction='status';

	public function actionSafemode()
	{
		$this->render('safemode', array('product'=>Yii::app()->user->branding->product) );
	}
    public function actionCorrupted()
	{
		$this->render('corrupted', array('product'=>Yii::app()->user->branding->product) );
	}
    
	public function actionStatus()
	{

        $info = new BasicInfo;
        $config = new PlayerConfig;
        $modem = new Modem3G;
        $usb = new USBInfo;
        
        $config->loadConfig();
        
		$this->render('status',array(   'info'=>$info, 
                                        'serial'=>Yii::app()->user->info->serialstring,
                                        'hardware' => Yii::app()->user->info->hardware,
                                        'name' => $config->deviceName,
                                        'screen' => $config->screenId,
                                        'modem' => $modem,
                                        'usb' => $usb,
                                        'config' => $config
                                        ) );
	}
    public function actionSnapshot()
	{
        $this->render('snapshot',array( ) );
    }
	public function actionDisplay()
	{
        $info = new ScreenInfo;
        $info->load();

        $this->render('display',array( 'info'=>$info) );
    }
    public function actionStorage()
	{
        $disk = new DiskInfo;
        $disk->load();
        $this->render('storage',array( 'disk'=>$disk ) );
    }
    public function actionLogs()
	{
        $logs = new LogsInfo;
        $logs->load();
        $this->render('logs',array( 'logs'=>$logs) );
    }
    public function actionAbout()
	{
        $this->render('about',array( ) );
    }
}